import ConfigParser, os

class MbusCfg:
    def __init__( self ):
	cfg = ConfigParser.ConfigParser()
	if os.environ.has_key( "MBUS" ):
	    cfg.read( os.environ[ "MBUS" ] )
	else:
	    cfg.read( "%s/%s"%(os.environ["HOME"],".mbus") )
	try:
	    self.addr = cfg.get( "MBUS", "ADDRESS" )
	except ConfigParser.NoOptionError:
	    # rfc says: self.addr = "239.255.255.247"
	    # but this is the c++ mbus default:
	    self.addr = "224.255.222.239"
	try:
	    self.port = cfg.get( "MBUS", "PORT" )
	except ConfigParser.NoOptionError:
	    self.port = "47000"
	self.port = int( self.port )
	try:
	    self.scope = cfg.get( "MBUS", "SCOPE" )
	except ConfigParser.NoOptionError:
	    self.scope = "HOSTLOCAL"
	try:
	    self.cfgvers = cfg.get( "MBUS", "CONFIG_VERSION" )
	except ConfigParser.NoOptionError:
	    self.cfgvers = "1"
	try:
	    self.hashkey = cfg.get( "MBUS", "HASHKEY" )
	except ConfigParser.NoOptionError:
	    raise "Missing Hashkey in Configfile"
	try:
	    self.encrkey = cfg.get( "MBUS", "ENCRYPTIONKEY" )
	except ConfigParser.NoOptionError:
	    self.encrkey = "(NOENCR, )"
	# pyMbus specific additions
	try:
	    self.unicast = cfg.get( "MBUS", "SEND_UNICAST" )
	    if self.unicast != "no" and self.unicast != "No" and self.unicast != "NO":
		self.unicast = 1
	    else:
		self.unicast = 0
	except:
	    self.unicast = 1
