"""Simple mainloop that watches __sockets and __timers."""

from select import select
from time import time

__sockets = {}
__timers = []

def addSocket( socket, method ):
    """The first argument specifies a socket, the second argument has to be a
    function that is called whenever there is data ready in the socket.
    The callback function gets the socket back as only argument."""
    __sockets[socket] = method

def removeSocket( socket ):
    """Removes the given socket from scheduler."""
    del __sockets[socket]

def addTimer( interval, method, data = None ):
    """The first argument specifies an interval in seconds, the second argument
    a function. This is function is called after interval seconds. If it
    returns true it's called again after interval seconds, otherwise it is
    removed from the scheduler. The third (optional) argument is a parameter
    given to the called function."""
    __timers.append( (interval, time(), method, data) )

def removeTimer( method ):
    """Removes _all_ functioncalls to the method given as argument from the
    scheduler."""
    remove = []
    for i in range( 0, len(__timers) ):
	if __timers[i][2] == method:
	    remove.append( i )
    remove.reverse()
    for i in remove: del __timers[i]

def loop():
    """Execute main loop forver."""
    while 1:
	step()

def step():
    # IDEA: Add parameter to specify max timeamount to spend in mainloop
    """Do one step forward in the main loop."""
    # handle timers
    remove = []
    i = 0
    while i < len( __timers ):
	if __timers[i][0] + __timers[i][1] <= time():
	    retval = None
	    try:
		if not __timers[i][2]( __timers[i][3] ):
		    remove.append( i )
		else:
		    __timers[i] = \
			( __timers[i][0], time(), __timers[i][2], \
			       __timers[i][3] )
	    except DeadTimerException: remove.append( i )
        i += 1
    # remove functions that returned false from scheduler
    remove.reverse()
    for r in remove: del __timers[r]
    # get minInterval for max timeout
    timeout = None
    for i in __timers:
	if timeout == None or i[0] < timeout:
	    nextCall = i[0] + i[1] - time()
	    if nextCall > 0: timeout = nextCall
	    else: timeout = 0
    # handle __sockets
    r, w, e = select( __sockets.keys(), [], [], timeout )
    for sock in r: __sockets[sock]( sock )

class DeadTimerException:
    def __init__( self ): pass
