#!/usr/bin/env python

import sys
from string import split, strip
from mbus import mbusif, mbustypes

def userInput( socket ):
    input = socket.readline()
    if input[0] == "(": # target address given
	addr, input = split( input[1:], ")", 1 )
	addr = strip( addr )
    else:
	addr = ""
    mbus.sendraw( addr, input )

# float check

def float_check( data ):
    m = mbustypes.MMessage( "" )
    m.payload.append( mbustypes.MCommand( "mbus.float" ) )
    m.payload[-1].args = [ 1.0 ]
    mbus.send( m )
    return 1

# notifier-timer testfunction
def bla( data ):
    m = mbustypes.MMessage( "" )
    m.payload.append( mbustypes.MCommand( "mbus.python" ) )
    m.payload[-1].args = [ 'python', 'rules', [ 1, 2, [ 1, 2, 3, 4] ], \
		    mbustypes.MSymbol( "somewhat" ) ]
    mbus.send( m )
    return 1 # return true for endless looping,
	     # nothing or false to be removed from scheduler

# message notification testfunction
def hello( mmessage, data = None ):
    print mmessage.asString()
    # return values see bla()

# 
def newEntity( maddr ):
    print "New Entity:",
    for key in maddr.keys():
	print "%s:%s"%( key, maddr[key] ),
    print

def lostEntity( maddr ):
    print "Lost Entity:",
    for key in maddr.keys():
	print "%s:%s"%( key, maddr[key] ),
    print

def unknown( mmessage ):
    print "received unknown message:"
    print mmessage.asString()

def transporterror( e ):
    print "Mbus transport error occured:", e.descr
    print "MMessage content:"
    print e.mmsg

# create mbus entity
mbus = mbusif.MbusIF( "app:test lang:python" )

# register special callbacks (optional)
mbus.newEntityFunction      = newEntity
mbus.lostEntityFunction     = lostEntity
mbus.unknownMessageFunction = unknown
mbus.errorFunction          = transporterror

#mbus.addTimer( 3, bla )
#mbus.addTimer( 3, float_check )
#mbus.addCallback( "mbus.hello", hello )
mbus.addSocket( sys.stdin, userInput )

try:
    mbus.loop()
#except TypeError, e:
#    print e
except mbustypes.MbusError, e:
    print e.msg
except KeyboardInterrupt:
    pass
