#!/usr/bin/env python

from mbus import mbusif
from mbus import mbustypes

def test_reconfigure( mbus ):
    print "Reconfiguring..."
    mbus.reconfigure( "app:reconfigured lang:python" )
    return 1

def newEntity( maddr ):
    print "New Entity:",
    for key in maddr.keys():
	print "%s:%s"%( key, maddr[key] ),
    print

def lostEntity( maddr ):
    print "Lost Entity:",
    for key in maddr.keys():
	print "%s:%s"%( key, maddr[key] ),
    print

def unknown( mmessage ):
    print "received unknown message:"
    print mmessage.asString()

def transporterror( e ):
    print "Mbus transport error occured:", e.descr
    print "MMessage content:"
    if e.mmsg:
	print e.mmsg.header.srcAdr, e.mmsg.header.destAdr


# create mbus entities
mbus = []
for i in range(0,20):
    mbus.append( mbusif.MbusIF( "app:test%d lang:python"%(i) ) )
    mbus[-1].newEntityFunction		= newEntity
    mbus[-1].lostEntityFunction		= lostEntity
    mbus[-1].unknownMessageFunction	= unknown
    mbus[-1].errorFunction		= transporterror

mbus[-1].addTimer( 2, test_reconfigure, mbus[-1] )

try:
    mbus[-1].loop()
#except TypeError, e:
#    print e
except mbustypes.MbusError, e:
    print e.descr
    print e.mmsg
except KeyboardInterrupt:
    pass
