#!/usr/bin/env python

from mbus import mbusif
from mbus import mbustypes
from mbus import mbusguides

svradr = None	# address of server

def send_rpc_sum( data ):
    if svradr:
	mbus.sendRPC( svradr, "rpc.sum", [ 1, 2, 3, 4 ], recv_rpc_sum )
    return 1

def recv_rpc_sum( return_list, data = None ):
    # return list can only contain one triple because it's an unicast rpc
    adr    = return_list[0][0] # first element holds senders address
    status = return_list[0][1] # second is for app specific status
    result = return_list[0][2] # third is the "real" result
    print "received rpc sum: ", result

def newEntity( maddr ):
    print "New Entity:",
    for key in maddr.keys():
	print "%s:%s"%( key, maddr[key] ),
    print
    if maddr.has_key( "name" ) and maddr["name"] == "rpcsvr":
	global svradr
	svradr = maddr

def lostEntity( maddr ):
    print "Lost Entity:",
    for key in maddr.keys():
	print "%s:%s"%( key, maddr[key] ),
    print
    if maddr.has_key( "name" ) and maddr["name"] == "rpcsvr":
	global svradr
	svradr = None

def unknown( mmessage ):
    print "received unknown message:"
    print mmessage.asString()

def transporterror( e ):
    print "Mbus transport error occured:", e.descr
    print "MMessage content:"
    if e.mmsg != None: print e.mmsg.header.srcAdr, e.mmsg.header.destAdr

# create mbus entity
mbus = mbusguides.Guidelines( "name:rpcclt type:test lang:python" )

# register special callbacks (optional)
mbus.newEntityFunction      = newEntity
mbus.lostEntityFunction     = lostEntity
mbus.unknownMessageFunction = unknown
mbus.errorFunction          = transporterror

# try rpc every 5 seconds
mbus.addTimer( 5, send_rpc_sum )

try:
    mbus.loop()
#except TypeError, e:
#    print e
except mbustypes.MbusError, e:
    print e.descr
    print e.mmsg
except KeyboardInterrupt:
    pass
