#!/usr/bin/env python

from mbus import mbusif
from mbus import mbustypes
from mbus import mbusguides

def rpc_sum( adr, val, data = None ):
    print "rpc_sum: incoming call from:",adr
    print "building sum of:", val
    res = 0
    for i in val: res += i
    return mbusguides.RPCReturn( [ res ] )

def newEntity( maddr ):
    print "New Entity:",
    for key in maddr.keys():
	print "%s:%s"%( key, maddr[key] ),
    print

def lostEntity( maddr ):
    print "Lost Entity:",
    for key in maddr.keys():
	print "%s:%s"%( key, maddr[key] ),
    print

def unknown( mmessage ):
    print "received unknown message:"
    print mmessage.asString()

def transporterror( e ):
    print "Mbus transport error occured:", e.descr
    print "MMessage content:"
    print e.mmsg.header.srcAdr, e.mmsg.header.destAdr

# create mbus entity
mbus = mbusguides.Guidelines( "name:rpcsvr type:test lang:python" )

# register special callbacks (optional)
mbus.newEntityFunction      = newEntity
mbus.lostEntityFunction     = lostEntity
mbus.unknownMessageFunction = unknown
mbus.errorFunction          = transporterror

mbus.addRPCCallback( "rpc.sum", rpc_sum )

try:
    mbus.loop()
#except TypeError, e:
#    print e
except mbustypes.MbusError, e:
    print e.descr
    print e.mmsg
except KeyboardInterrupt:
    pass
